unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, StdCtrls, RXCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Image1: TImage;
    PaintBox4: TPaintBox;
    PaintBox5: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Panel3: TPanel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure PaintBox5Paint(Sender: TObject);
    procedure PaintBox4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox4Paint(Sender: TObject);
    procedure PaintBox4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    Des:Boolean;
    bmp:array[0..2] of TBitmap;
    Saha,tet:TBitmap;
    Posi:TPoint;
    nbrt,scor:array[1..2] of Integer;
    MLabel,scorL:array[1..2] of TLabel;
    Procedure Initialise;
    Procedure MonMessage(var MSG:TMessage);message wm_user;
    Function  Teste(x,y:Integer):Boolean;
    Procedure TraceLine(x1,y1,x2,y2:Integer);

  public
    { Dclarations publiques }

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
   chamain_wav='C:\WINDOWS\Help\Tours\WindowsMediaPlayer\Audio\Wav\';
   nom_wav='wmpaud';
   ext_wav='.wav';
var
   Tabl:Array[0..5,0..6] of byte;
   m,n:integer;
   Joueur,Ptet:integer;
   coul:TColor;
Procedure TForm1.Initialise;
var
     i,j:Integer;
     rec:TRect;
begin
     FillChar(tabl,sizeof(tabl),0);
     Joueur:=1;
     Panel3.Caption:='Joueur 1';
     FillChar(Posi,sizeof(Posi),0);
     Des:=false;
     FillChar(nbrt,sizeof(nbrt),0);
     Label1.Caption:='0';
     Label2.Caption:='0';
     rec:=tet.Canvas.ClipRect;
     tet.Canvas.Rectangle(rec);
     saha.Width:=m*7;
     saha.Height:=n*6;
     Tet.Width:=m*7;
     tet.Height:=n;
     tet.Canvas.Draw(0,0,bmp[joueur]);
     Ptet:=0;
     for i:=0 to 7 do
       for j:=0 to 6 do
         begin
           saha.Canvas.Draw(i*m,j*n,bmp[0]);
         end;
     PaintBox4.Refresh;
     PaintBox5.Refresh;
end;
procedure TForm1.MonMessage;
begin
//     panel1.Height:=n;
//     PaintBox4.Width:=pain*7;
     MLabel[1]:=Label1;
     MLabel[2]:=Label2;
     scorL[1]:=Label3;
     scorL[2]:=Label4;
end;
procedure TForm1.FormCreate(Sender: TObject);
var
     i:integer;
     rec,recs:TRect;
begin
     scor[1]:=0;
     Scor[2]:=0;
     DoubleBuffered:=true;
     PANEL1.DoubleBuffered:=true;
     coul:=Image1.Canvas.Pixels[0,0];
     m:=Image1.Width div 3;
     n:=Image1.Height;
     rec:=rect(0,0,m,n);
     for i:=0 to 2 do
       begin
         bmp[i]:=TBitmap.Create;
         bmp[i].Height:=n;
         bmp[i].Width:=m;
         recs:=rect(rec.Right*i,rec.Top,rec.Right*(i+1),rec.Bottom);
         bmp[i].Canvas.CopyRect(rec,image1.Canvas,recs);
       end;
     Saha:=TBitmap.Create;
     saha.Canvas.Pen.Width:=10;
     tet:=TBitmap.Create;
     tet.Canvas.Brush.Color:=coul;
     tet.Canvas.Pen.Color:=coul;
     Initialise;
     PostMessage(handle,wm_user,0,0);
end;

procedure TForm1.PaintBox5Paint(Sender: TObject);
var  rec:TRect;
begin
     rec:=PaintBox5.ClientRect;
     PaintBox5.Canvas.StretchDraw(rec,saha);
end;

procedure TForm1.PaintBox4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var  i,j:integer;
     rec:TRect;
     l,ml:integer;
begin
     if Des  then exit;
     des:=true;
     l:=ptet;ml:=ptet*m;
     rec:=tet.Canvas.ClipRect;
     tet.Canvas.Rectangle(ml,0,ml+m,n);
     PaintBox4.Refresh;
     i:=-1;
     while (i<5) and (Tabl[i+1,l]=0) do
       begin
         inc(i);
         saha.Canvas.Draw(ml,i*n,bmp[joueur]);
         PaintBox5.Refresh;
         for j:=1 to 5 do
          begin
            application.ProcessMessages;
            sleep(1);
          end;
         if (i<5) and (Tabl[i+1,l]=0) then
           begin
             saha.Canvas.Draw(ml,i*n,bmp[0]);
             PaintBox5.Refresh;
             for j:=1 to 1 do
              begin
                application.ProcessMessages;
                sleep(1);
              end;
           end;
       end;
     if i>=0 then
       begin
         tabl[i,l]:=joueur;
         inc(nbrt[joueur]);
         MLabel[joueur].Caption:=inttostr(nbrt[Joueur]);
         if Teste(i,l) then
           begin
             showmessage('le joueur: '+inttostr(Joueur)+'  gagner');
             inc(scor[Joueur]);
             scorL[joueur].Caption:=inttostr(scor[joueur]);
             Initialise;
             exit;
           end;
         if nbrt[1]+nbrt[2]>=42 then
           begin
              showmessage('galit');
              Initialise;
              exit;
           end;
         Joueur:=3-joueur;
         Panel3.Caption:='Joueur '+inttostr(joueur);
       end;
     tet.Canvas.Draw(ptet*m,0,bmp[joueur]);
     PaintBox4.Refresh;
     des:=false;
{     i:=PaintBox4.Width div 7;
     i:=(x div i);
     if i<>Ptet then
       begin
         rec:=tet.Canvas.ClipRect;
         tet.Canvas.Rectangle(Ptet*m,0,(Ptet+1)*m,n);
         Ptet:=i;
         tet.Canvas.Draw(i*m,0,bmp[joueur]);
         PaintBox4.Refresh;
       end;}
end;
Function  TForm1.Teste;
var
  x1,y1,x2,y2:Integer;
  v,d:integer;
  Function  TestHoriz:boolean;
  var  i,nbr:integer;
  begin
       i:=x+1;nbr:=1;
       x1:=x;y1:=y;
       while (i<=5) and (Tabl[i,y]=Joueur) do
         begin
            inc(i);
            inc(nbr);
         end;
       result:=(nbr=4);
       if result then
         begin
           x2:=i-1;y2:=y;
         end;
  end;
  Function  TestVerti:boolean;
  var  i,j,nbr:integer;
  begin
       i:=y-1;nbr:=1;
       x1:=x;
       while (nbr<4) and (i>=0) and (Tabl[x,i]=Joueur) do
         begin
            dec(i);
            inc(nbr);
         end;
       j:=i+1;
       i:=y+1;
       while (nbr<4) and (i<=6) and (Tabl[x,i]=Joueur) do
         begin
            inc(i);
            inc(nbr);
         end;
       result:=(nbr=4);
       if result then
         begin
           y1:=j;x2:=x;y2:=i-1;
         end;
  end;
  Function  TestDiagoG:boolean;
  var  i,j,nbr:integer;
  begin
       i:=y-1;nbr:=1;
       j:=x-1;
       while (nbr<4) and (i>=0) and (j>0) and (Tabl[j,i]=Joueur) do
         begin
            dec(i);dec(j);
            inc(nbr);
         end;
       y1:=i+1;x1:=j+1;
       j:=x+1;
       i:=y+1;
       while (nbr<4) and (i<=6) and (j<=5) and (Tabl[j,i]=Joueur) do
         begin
            inc(i);inc(j);
            inc(nbr);
         end;
       y2:=i-1;x2:=j-1;
       result:=(nbr=4);
  end;
  Function  TestDiagoD:boolean;
  var  i,j,nbr:integer;
  begin
       i:=y+1;nbr:=1;
       j:=x-1;
       while (nbr<4) and (i<=5) and (j>=0) and (Tabl[j,i]=Joueur) do
         begin
            inc(i);dec(j);
            inc(nbr);
         end;
       y1:=i-1;x1:=j+1;
       j:=x+1;
       i:=y-1;
       while (nbr<4) and (i>=0) and (j<=6) and (Tabl[j,i]=Joueur) do
         begin
            dec(i);inc(j);
            inc(nbr);
         end;
       y2:=i+1;x2:=j-1;
       result:=(nbr=4);
  end;
begin
     result:=TestHoriz or TestVerti or TestDiagoG or TestDiagoD;

     if Result then
       begin
         y1:=((((y1 shl 1)+1)*m) shr 1);
         x1:=((((x1 shl 1)+1)*n) shr 1);
         y2:=((((y2 shl 1)+1)*m) shr 1);
         x2:=((((x2 shl 1)+1)*n) shr 1);
         Form1.TraceLine(y1,x1,y2,x2);
       end;
end;
procedure TForm1.TraceLine;
begin
     saha.Canvas.MoveTo(x1,y1);
     saha.Canvas.LineTo(x2,y2);
     PaintBox5.Refresh;
end;
procedure TForm1.PaintBox4Paint(Sender: TObject);
var  rec:TRect;
begin
     rec:=PaintBox4.ClientRect;
     PaintBox4.Canvas.StretchDraw(rec,tet);
end;

procedure TForm1.PaintBox4MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var  i:integer;
     rec:TRect;
begin
     i:=PaintBox4.Width div 7;
     i:=(x div i);
     if i<>Ptet then
       begin
         if not des then
           begin
             rec:=tet.Canvas.ClipRect;
             tet.Canvas.Rectangle(Ptet*m,0,(Ptet+1)*m,n);
             tet.Canvas.Draw(i*m,0,bmp[joueur]);
             PaintBox4.Refresh;
           end;
         Ptet:=i;
       end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     Panel1.Height:=PaintBox5.Height div 6;
     PaintBox4.Width:=PaintBox5.Width;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
     i:Integer;
     rec:TRect;
begin
     i:=TPaintBox(sender).Tag;
     rec:=TPaintBox(sender).ClientRect;
     TPaintBox(sender).Canvas.StretchDraw(rec,bmp[i]);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
     i:integer;
begin
     for i:=0 to 2 do  bmp[i].Free;
     Saha.Free;
     tet.Free;
     sleep(10);
end;

end.
